function check_host_status(editor)
{
    if(check_allowed && check_hosts)
    {
        //var cells=editor.graph.getChildCells(editor.graph.getDefaultParent(), true, true);
        var cells=editor.graph.getChildVertices(editor.graph.getDefaultParent());
        var ips_s=[];
        var ip="";
        var c_l=cells.length;
        var service_name="";
	var sData=[];
	var state;
	var sOut;
	var sobject; 
        for(i=0;i < c_l; i++)
        {
	    ip="";
            //try{ ip=cells[i].getAttribute('ip');}
            //catch(err){;}
	    try
            {
		object_type=cells[i].getAttribute('object_type');
		if(object_type==='host_nagios') ip=cells[i].getAttribute('IP');
		else ip='0';
            }
            catch(err)
            {
                ip="";
            }
            try
            {
		service_name=cells[i].getAttribute('service_name');
            }
            catch(err)
            {
                service_name="";
            }
            ips_s[i]='"'+ip+'"'+'|'+service_name;
        }	
        if(cells.length>0)
        {
	   checking_info_h('Hosts');
	   
           $.ajax({
                url: "check_host_nagios_state.php",
                async: false,
                dataType: "text",
                type: "POST",
                data: ({ips_s:               ips_s,
                        host_service:        "host",
                        check_host_services: 0 //check_host_services  //1-check services 0-no check
		}),
                success: function(data){			   
                           var ss=data.split("@@");
                           var service_name="";
                           var s_s=ss.length;
                           for(i=0;i<s_s;i++)
                           {
                                sData  =      ss[i].split('|');
                                ip     =      sData[0];
                                service_name =sData[1]; //is empty for host
                                state  =      sData[2];
                                sOut   =      sData[3];
                                sobject=      sData[4]; //service or host
				//try{ s_name=cells[i].getAttribute('service_name');}
                                //catch(err){ s_name="";}				
                                if(sobject === 'host_nagios') // ip !== 0 && ip !== "0" && ip !== "" && typeof(ip) !== "undefined" && ip !== null && ip !== "undefined" && ip !=='undefined' && ip !== '"undefined"')) //&& (service_name === "" || typeof(service_name) === "undefined" || service_name === null || service_name === "undefined"))
                                {
				    //alert(sobject+" -- "+state);
                                            if(state === 0 || state === "0") //host ok
                                            {
						editor.graph.removeCellOverlays(cells[i]);
                                                editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_ok, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                            } else 
						{    
                                                        if(state === 1 || state === "1") //host critical
                                                        {   
							    editor.graph.removeCellOverlays(cells[i]);
                                                            editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_critical, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                        } else 
							    {
								if(state === 2 || state === "2")
								{
								    editor.graph.removeCellOverlays(cells[i]);								    
								    editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_warning, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));

								    //if(show_services_output === 1)
								    //{
									//cells[i].value.removeAttribute('label');
									//cells[i].setAttribute('label',s_name+'<br />'+sOut);
									//editor.graph.refresh(cells[i]);
								    //}    
								} else 
								    {
									if(state === 3 || state === "3") //unknown state
									{
									    editor.graph.removeCellOverlays(cells[i]);
									    editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_unknown, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
									} else //for state===4
									    {
										editor.graph.removeCellOverlays(cells[i]);
									    }
								    }
                                                            }
                                                }
                                }
                           }
                }
           });
        }  
    }     
};


function check_service_status(editor)
{
    if(check_allowed && check_services)
    {
        //var cells=editor.graph.getChildCells(editor.graph.getDefaultParent(), true, true);
        var cells=editor.graph.getChildVertices(editor.graph.getDefaultParent());
        var ips_s=[];
        var service_name="";
        var ip="";
	var state;
	var sOut;
	var sobject;
	var sData=[];
        var c_c=cells.length;
        for(i=0;i < c_c; i++)
        {
            try
            {
                ip=cells[i].getAttribute('IP');
            }
            catch(err)
            {
                ip="";
            }    
            try
            {
                //var st =editor.graph.model.getStyle(cells[i]);
                //var spos=st.indexOf('service_nagios');
		var object_type=cells[i].getAttribute('object_type');
                if(object_type === "service_nagios")
                {                
                    service_name=cells[i].getAttribute('service_name');
                } else service_name="";
            }
            catch(err)
            {
                service_name="";
            }
            ips_s[i]='"'+ip+'"'+'|'+service_name;
        }
        if(c_c > 0)
        {
	   checking_info_s('Services');

           $.ajax({
                url: "check_host_nagios_state.php",
                async: false,
                dataType: "text",
                type: "POST",
                data: ({ips_s:               ips_s,
                        host_service:        "services",
                        check_host_services: ""}),
                success: function(data){			   
                           var ss=data.split("@@");
                           var service_name="";
                           var s_name="";
                           var s_s=ss.length;
                           for(i=0;i<s_s;i++)
                           {
                                sData  =      ss[i].split('|');
                                ip     =      sData[0];
                                service_name =sData[1];
                                state  =      sData[2];
                                sOut   =      sData[3];
                                sobject=      sData[4]; //service or host                                				
                                if(sobject === 'service_nagios')    //(service_name !== 0 && service_name !== "0" && service_name !== "" && typeof(service_name) !== "undefined" && service_name !== null && service_name !== "undefined" && service_name !== '"undefined"') //for services
                                {
				    try{ s_name=cells[i].getAttribute('service_name');}
				    catch(err){ s_name="";}
				    
                                    if(state === 0 || state === "0")
                                    {
					editor.graph.removeCellOverlays(cells[i]);
                                        editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_ok, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                        if(show_services_output === 1)
                                        {
                                            //cells[i].value.removeAttribute('label');
                                            cells[i].setAttribute('label',s_name+'<br />'+sOut);
					    editor.graph.refresh(cells[i]);
                                        }    
                                     } else 
					{
                                                if(state === 1 || state === "1")
                                                {
                                                    editor.graph.removeCellOverlays(cells[i]);
                                                    editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_warning, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                    if(show_services_output === 1)
                                                    {
                                                        //cells[i].value.removeAttribute('label');
                                                        cells[i].setAttribute('label',s_name+'<br />'+sOut);	
							editor.graph.refresh(cells[i]);
                                                    }    
                                                } else 
						    {
                                                            if(state === 2 || state === "2") 
                                                            {
                                                                editor.graph.removeCellOverlays(cells[i]);
                                                                try
                                                                {
                                                                    editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_critical, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                                }
                                                                catch(err)
                                                                {
                                                                    editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_critical, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                                }
                                                                if(show_services_output === 1)
                                                                {
                                                                    //cells[i].value.removeAttribute('label');
                                                                    cells[i].setAttribute('label',s_name+'<br />'+sOut);
								    editor.graph.refresh(cells[i]);
                                                                }    
                                                            } else 
								{
                                                                        if(state === 3 || state === "3")
                                                                        {
                                                                            editor.graph.removeCellOverlays(cells[i]);  
                                                                            editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_unknown, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                                            //if(show_services_output) editor.graph.model.setValue(cells[i], sOut);
                                                                        } else //for state===4
									{
									    editor.graph.removeCellOverlays(cells[i]);
									}
                                                                }
                                                    }
                                        }  
                                }
                           }
                }
           });
        }	
    }     
};

function check_host_status_href(editor)
{
    if(check_allowed && check_hosts)
    {
        //var cells=editor.graph.getChildCells(editor.graph.getDefaultParent(), true, true);
        var cells=editor.graph.getChildVertices(editor.graph.getDefaultParent());
        var ips_s=[];
        var ip="";
        var c_l=cells.length;
        var service_name="";
        for(i=0;i < c_l; i++)
        {
            try
            {
                ip=cells[i].getAttribute('ip');
            }
            catch(err)
            {
                ip="";
            }    
            /*try
            {
                var st = editor.graph.model.getStyle(cells[i]);
                var spos=st.indexOf('service');
                if(spos >= 0)
                {                
                    service_name=cells[i].getAttribute('service_name');
                } else service_name="";
            }
            catch(err)
            {
                service_name="";
            }*/
            ips_s[i]='"'+ip+'"'+'|'+service_name;
        }
        if(cells.length>0)
        {    
           $.ajax({
                url: "check_host_nagios_state.php",
                async: false,
                dataType: "text",
                type: "POST",
                data: ({ips_s:               ips_s,
                        host_service:        "host",
                        check_host_services: check_host_services}),
                success: function(data){
                           var ss=data.split("@@");
                           var service_name="";
                           var s_s=ss.length;
                           for(i=0;i<s_s;i++)
                           {
                                sData  =      ss[i].split('|');
                                ip     =      sData[0];
                                service_name =sData[1]; //is empty for host
                                state  =      sData[2];
                                sOut   =      sData[3];
                                sobject=      sData[4]; //service or host
                                /*try
                                {
                                    service_name=cells[i].getAttribute('service_name');
                                }
                                catch(err)
                                {
                                    service_name="";
                                }*/
                                if((ip !== 0 && ip !== "0" && ip !== "" && typeof(ip) !== "undefined" && ip !== null && ip !== "undefined" && ip !=='undefined' && ip !== '"undefined"')) //&& (service_name === "" || typeof(service_name) === "undefined" || service_name === null || service_name === "undefined"))
                                {
                                    var st = editor.graph.model.getStyle(cells[i]);
                                    editor.graph.removeCellOverlays(cells[i]);
                                    /*if(check_host_services===1)
                                            {    
                                        if(state === 1 || state === "1")
                                        {
                                            editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_warning, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                            //if(show_services_output) editor.graph.model.setValue(cells[i], sOut);
                                        } else {
                                                    if(state === 2 || state === "2")
                                                    {
                                                        try
                                                        {
                                                            editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_critical, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                        }
                                                        catch(err)
                                                        {
                                                            editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_warning, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                        }
                                                        //if(show_services_output) editor.graph.model.setValue(cells[i], sOut);
                                                    } else {
                                                                if(state === 3 || state === "3")
                                                                {
                                                                    editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_unknown, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                                    //if(show_services_output) editor.graph.model.setValue(cells[i], sOut);
                                                                }
                                                           }
                                               }
                                    } else*/
                                        //{
                                            if(state === 1 || state === "1") //host ok
                                            {
                                                editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_ok, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                //if(show_services_output) editor.graph.model.setValue(cells[i], sOut);
                                            } else {    
                                                        if(state === 0 || state === "0") //host critical
                                                        {   
                                                            try
                                                            {
                                                                editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_critical, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                            }
                                                            catch(err)
                                                            {
                                                                editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_warning, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                            }
                                                            //if(show_services_output) editor.graph.model.setValue(cells[i], sOut);
                                                        } else {
                                                                    //if(state === 3 || state === "3") //unknown state
                                                                    //{
                                                                        editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_unknown, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                                        //if(show_services_output) editor.graph.model.setValue(cells[i], sOut);
                                                                    //}
                                                               }
                                                   }            
                                        //}
                                }
                           }
                }
           });
        }  
    }     
};


function check_service_status_href(editor)
{
    if(check_allowed && check_services)
    {
        //var cells=editor.graph.getChildCells(editor.graph.getDefaultParent(), true, true);
        var cells=editor.graph.getChildVertices(editor.graph.getDefaultParent());
        var ips_s=[];
        var service_name="";
        var ip="";
        var c_c=cells.length;
        for(i=0;i < c_c; i++)
        {
            try
            {
                ip=cells[i].getAttribute('ip');
            }
            catch(err)
            {
                ip="";
            }    
            try
            {
                var st =editor.graph.model.getStyle(cells[i]);
                var spos=st.indexOf('service');
                if(spos >= 0)
                {                
                    service_name=cells[i].getAttribute('service_name');
                } else service_name="";
            }
            catch(err)
            {
                service_name="";
            }
            ips_s[i]='"'+ip+'"'+'|'+service_name;
        }
        if(c_c > 0)
        {    
           $.ajax({
                url: "check_host_nagios_state.php",
                async: false,
                dataType: "text",
                type: "POST",
                data: ({ips_s:               ips_s,
                        host_service:        "services",
                        check_host_services: ""}),
                success: function(data){
                           var ss=data.split("@@");
                           var service_name="";
                           var s_name="";
                           var s_s=ss.length;
                           for(i=0;i<s_s;i++)
                           {
                                sData  =      ss[i].split('|');
                                ip     =      sData[0];
                                service_name =sData[1];
                                state  =      sData[2];
                                sOut   =      sData[3];
                                sobject=      sData[4]; //service or host
                                try
                                {
                                    s_name=cells[i].getAttribute('service_name');
                                }
                                catch(err)
                                {
                                    s_name="";
                                }
                                if(service_name !== 0 && service_name !== "0" && service_name !== "" && typeof(service_name) !== "undefined" && service_name !== null && service_name !== "undefined" && service_name !== '"undefined"') //for services
                                {
                                    if(state === 0 || state === "0")
                                    {
                                        editor.graph.removeCellOverlays(cells[i]);
                                        editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_ok, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                        if(show_services_output)
                                        {
                                            cells[i].value.removeAttribute('label');
                                            cells[i].setAttribute('label',s_name+'<br />'+sOut);
                                        }    
                                     } else {
                                                if(state === 1 || state === "1")
                                                {
                                                    editor.graph.removeCellOverlays(cells[i]);
                                                    editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_warning, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                    if(show_services_output)
                                                    {
                                                        cells[i].value.removeAttribute('label');
                                                        cells[i].setAttribute('label',s_name+'<br />'+sOut);
                                                    }    
                                                } else {
                                                            if(state === 2 || state === "2")
                                                            {
                                                                editor.graph.removeCellOverlays(cells[i]);
                                                                try
                                                                {
                                                                    editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_critical, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                                }
                                                                catch(err)
                                                                {
                                                                    editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_warning, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                                }
                                                                if(show_services_output) 
                                                                {
                                                                    cells[i].value.removeAttribute('label');
                                                                    cells[i].setAttribute('label',s_name+'<br />'+sOut);
                                                                }    
                                                            } else {
                                                                        //if(state === 3 || state === "3")
                                                                        //{
                                                                            editor.graph.removeCellOverlays(cells[i]);  
                                                                            editor.graph.addCellOverlay(cells[i], new mxCellOverlay(w_image_unknown, "",mxConstants.ALIGN_RIGHT,mxConstants.ALIGN_TOP,offset_overlay));
                                                                            //if(show_services_output) editor.graph.model.setValue(cells[i], sOut);
                                                                        //}
                                                                   }
                                                      }
                                           }  
                                }
                           }
                }
           });
        }   
    }     
};
